import { FC, useEffect, useState } from 'react'
import { View } from '@tarojs/components'
import VideoList from '@/components/videoList/videoList'
import Taro from '@tarojs/taro'
import styles from './index.module.scss'

type Props = {
  data: any[]
}
const WaterFull: FC<Props> = ({data}) => {
  const [leftList,setLeftList] = useState<any[]>([])
  const [rightList,setRightList] = useState<any[]>([])
  const [tempList,setTempList] = useState<any[]>([])
  const [copyFlowList,setCopyFlowList] = useState<any[]>([])
  const startLength = copyFlowList.length
  // const query = Taro.createSelectorQuery()

  console.log(rightList.length,leftList.length,"高")


  useEffect(() => {
    setTempList(cloneData(data).splice(startLength))
    setCopyFlowList(cloneData(data))
  }, [data]);

  useEffect(() => {
    let tempArr = cloneData(tempList)
    splitData(tempArr)
  }, [tempList])


  async function splitData(arr: any[]){

    if (!arr.length) {
      return
    }
    // let leftHeight = await getRect('#wang-left-column')
    // let rightHeight = await getRect('#wang-right-column')
    // console.log("左侧高度",leftHeight,)
    let item = arr[0]
    Taro.nextTick(() => {
      arr.length % 2 == 0 ? setLeftList((data) => ([...data, item])) : setRightList((data) => ([...data, item]))
    })
    // if (leftHeight < rightHeight) {
    //   console.log("左侧插入",leftHeight,rightHeight)
    //   setLeftList((data) => ([...data,item]))
    // } else if (leftHeight > rightHeight) {
    //   console.log("右侧插入",leftHeight,rightHeight)
    //   setRightList((data) => ([...data,item]))
    // } else {
    //    console.log("左侧插入")
    //     setLeftList((data) => ([...data,item]))
    // }
    // 移除临时列表的第一项
    arr.splice(0, 1)
    // 如果临时数组还有数据，继续循环
    Taro.nextTick(() => {
      if (arr.length) {
          splitData(arr) // 在当前同步流程结束后，下一个时间片执行
      }
    })

  }

  // async function getRect(selector:string): Promise<number> {
  //   return new Promise((resolve) => {
  //
  //     query.select(selector).boundingClientRect()
  //     // 执行查询，获取结果
  //     query.exec((res) => {
  //       if (res && res[0]) {
  //         console.log('Element height:',res, res[0].height)
  //         resolve(res[0].height)
  //       }
  //     })
  //   })
  // }
  function cloneData(data:unknown[]) {
    return JSON.parse(JSON.stringify(data))
  }

  return (
    <View className={styles.wang_product}>
      <View className={[styles.product_water,styles.col_2_20].join(" ")}>
        <View className={styles.wang_waterfall}>
            <View id="wang-left-column" className={styles.wang_column}>
              <View className={`${styles.water} ${styles.left}`}>

                {leftList.map(d => <VideoList key={d.id} data={d} errorType='health'/>)}
              </View>
            </View>
            <View id="wang-right-column" className={styles.wang_column}>
              <View className={[styles.water,styles.right].join(" ")}>
                {rightList.map(d => <VideoList key={d.id} data={d} errorType='health'/>)}
              </View>
            </View>
        </View>
      </View>
    </View>
  )
}
export default WaterFull
